new const FT_DIR[]          = "frozentag";
new const FT_CVARFILE[]     = "config.cfg";

/*! Cvars */
new g_pUnfreezeTime;
new g_pUnfreezeRange;
new g_pRoundTime;
new g_pGameRoundTime;
new g_pShowKnife;
new g_pBlockMouseview;
new g_pAutoUnfreeze;
new g_pAutoUnfreezeTime;
new g_pShowBar;

/*! MaxPlayers */
new g_iMaxPlayers;

/*! Effects */
new g_iBarTime;
new g_iStatusIcon;

/*! Player Variables */
new CsTeams:g_iTeams[33];
new bool:g_isPlayerFrozen[33];
new g_iPlayerAngles[33][3];

new g_iTarget[33];
new g_iTargetOf[33];

/*! Frozen & Alive TTs */
new g_iFrozenRunners, g_iAliveRunners;

// Check if all the terrorist are frozen
public checkTerms()
{
	if(g_iAliveRunners == g_iFrozenRunners) {
		remove_task( TASKID_ROUNDEND )
		g_iAliveRunners = 0
		
		client_cmd( 0, "spk radio/ctwin.wav" )
		
		// Swap teams
		for ( new id = 1; id <= g_iMaxPlayers; id++ )
		{
			if(!is_user_connected(id))
				continue;
				
			fwUnfreezePlayer(id);
			
			switch(g_iTeams[ id ])
			{
				case CS_TEAM_T: 
				{
					user_silentkill(id);
				}
				case CS_TEAM_CT: 
				{
					set_user_frags(id, get_user_frags(id) + 1);
				}
			}
			
			set_task(1.0, "tskChangeTeam", id) // little bugfix
		}
	}
}

/*! Change team */
public tskChangeTeam(id)
{
	if(is_user_connected( id )) 
		switch(g_iTeams[id]) {
			case CS_TEAM_T: {
				cs_set_user_team(id, CS_TEAM_CT)
			}
			case CS_TEAM_CT: {
				cs_set_user_team(id, CS_TEAM_T)
			}
		}
}

/*! Freeze/Unfreeze publics */
public fwFreezePlayer(id) {
	if(is_user_alive(id) && is_user_connected(id)) {
		showStatusIcon(id, .show = 1);
		
		g_iFrozenRunners++;
		g_isPlayerFrozen[id] = true;

		set_pev(id, pev_flags, pev(id, pev_flags) | FL_FROZEN);
		pev(id, pev_v_angle, g_iPlayerAngles[id]);

		new ent = create_entity( "info_target" )

		new Float: iOrigin[ 3 ]
		entity_get_vector( id, EV_VEC_origin, iOrigin )
		
		set_pev( ent, pev_body, 1 )
		entity_set_model( ent, ice_model )
		
		iOrigin[ 2 ] -= 35;
		entity_set_origin( ent, iOrigin )
		
		set_pev( ent, pev_owner, id );
		set_rendering( ent, kRenderFxNone, 255, 255, 255, kRenderTransAdd, 255 )
			
		entity_set_string( ent, EV_SZ_classname, "ent_frozen" )
		entity_set_int( ent, EV_INT_solid, 2 )
		
		new Float: iOriginNew[ 3 ]
		entity_get_vector( id, EV_VEC_origin, iOriginNew )

		if(get_pcvar_num(g_pAutoUnfreeze)) {
			set_task(get_pcvar_float(g_pAutoUnfreezeTime), "fwUnfreezePlayer", TASKID_AUTOUNFREEZE);
		}
	}
}

public fwUnfreezePlayer(id) {
	if(is_user_alive(id) && is_user_connected(id)) {
		showStatusIcon(id);

		g_iFrozenRunners--;
		g_isPlayerFrozen[id] = false;

		set_pev(id, pev_flags, pev(id, pev_flags) & ~FL_FROZEN);

		new iEnt = find_ent_by_owner(0, "ent_frozen", id);
	
		if(pev_valid(iEnt))
			remove_entity(iEnt);

		remove_task(TASKID_AUTOUNFREEZE);
	}
}

stock makeBar(id, duration = 0) {
	message_begin(MSG_ONE_UNRELIABLE, g_iBarTime, _, id);
	write_short(duration);
	message_end();
}

stock showStatusIcon(id, show = 0) {
	message_begin(MSG_ONE, g_iStatusIcon, {0,0,0}, id);
	write_byte(show); // status (0=hide, 1=show, 2=flash)
	write_string("dmg_cold"); // sprite name
	write_byte(9); // red
	write_byte(132); // green
	write_byte(227); // blue
	message_end();
}

/*! Config */
public getConfigsDir(iName[], iLen)
{
	new iDirectory[64];
	get_localinfo("amxx_configsdir", iDirectory,63);
	
	return formatex(iName, iLen, "%s/%s", iDirectory, FT_DIR);
}

public makeConfigFile(const iFilepath[])
{
	new iFile = fopen(iFilepath, "wt");
	
	fprintf(iFile, "// Config of Frozen Tag by iNvectus^n");
	fprintf(iFile, "// Version %s^n", PLUGIN_VERSION);
	fprintf(iFile, "^n");
	
	fprintf(iFile, "// Cvars^n");
	fprintf(iFile, "^n");
	
	fprintf(iFile, "// Amount of time needed to unfreeze somebody ^n"); 
	fprintf(iFile, "ft_unfreeze_time ^"%s^"^n", get_pcvar_num(g_pUnfreezeTime));
	fprintf(iFile, "^n");

	fprintf(iFile, "// Range within a runner can unfreeze another runner ^n"); 
	fprintf(iFile, "ft_unfreeze_range ^"%s^"^n", get_pcvar_num(g_pUnfreezeRange));
	fprintf(iFile, "^n");

	fprintf(iFile, "// Amount of time the round will be played ^n"); 
	fprintf(iFile, "ft_roundtime ^"%s^"^n", get_pcvar_num(g_pGameRoundTime));
	fprintf(iFile, "^n");

	fprintf(iFile, "// If this is set to 1, the runner will be automatically unfrozen after amount of time ^n"); 
	fprintf(iFile, "ft_auto_unfreeze ^"%s^"^n", get_pcvar_num(g_pAutoUnfreeze));
	fprintf(iFile, "^n");

	fprintf(iFile, "// If the previous cvar is set to 1, the amount of time in the cvar will be used to automatically unfreeze the runner. ^n"); 
	fprintf(iFile, "ft_auto_unfreeze_time ^"%s^"^n", get_pcvar_num(g_pAutoUnfreezeTime));
	fprintf(iFile, "^n");

	fprintf(iFile, "// Block mouse viewing when a runner is frozen. Can be useful to prevent information leakage ^n"); 
	fprintf(iFile, "ft_block_mouseview ^"%s^"^n", get_pcvar_num(g_pBlockMouseview));
	fprintf(iFile, "^n");

	fprintf(iFile, "// Give knife and show it, without allowing attacks ^n"); 
	fprintf(iFile, "ft_show_knife ^"%s^"^n", get_pcvar_num(g_pShowKnife));
	fprintf(iFile, "^n");

	fprintf(iFile, "// Show a bar when unfreezing fellow runner, like the one when defusing a bomb ^n"); 
	fprintf(iFile, "ft_show_bar ^"%s^"^n", get_pcvar_num(g_pShowBar));
	fprintf(iFile, "^n");


	fclose(iFile);
	
	server_cmd("exec %s", iFilepath);
	server_exec();
}